package fr.enssat.lancer;


/**
 * Cette classe calcule la projection pixels -> scène
 * @author pierre
 *
 */
public class Camera
{
    // dimensions du dessin
    private int largeur;
    private int hauteur;

    // distance entre l'oeil et l'écran
    private float focale;

    // caméra
    private Point Oeil;


    /**
     * crée la caméra
     * @param largeur nombre de pixels horizontalement
     * @param hauteur nombre de pixels verticalement
     */
    public Camera(final int largeur, final int hauteur)
    {
        setSize(largeur, hauteur);
    }

    /**
     * change les dimensions de l'écran pour la caméra
     * @param largeur nombre de pixels horizontalement
     * @param hauteur nombre de pixels verticalement
     */
    public void setSize(final int largeur, final int hauteur)
    {
        this.largeur = largeur;
        this.hauteur = hauteur;

        // TODO calculer focale
        System.out.println("camera: "+largeur+"x"+hauteur+" @ "+Constantes.CHAMP+"° => focale="+focale);

        Oeil = new Point(0,0,-focale);
    }


    /**
     * construit un Rayon qui part de l'oeil et qui passe par (xe,ye) en coordonnées écran
     * @param xe absisse du pixel
     * @param ye ordonnée du pixel
     * @return Rayon(Oeil, pixel)
     */
    public Rayon getRayon(final float xe, final float ye)
    {
        // FIXME calcul des coordonnées monde du pixel, pensez à optimiser le plus possible
        Point pixel = new Point(xe, ye, 0);
        Vecteur direction = new Vecteur(Oeil, pixel).normalized();
        return new Rayon(pixel, direction);
    }


    public int getLargeur()
    {
        return largeur;
    }


    public int getHauteur()
    {
        return hauteur;
    }
}
