package fr.enssat.lancer;

import org.ini4j.Profile.Section;

/**
 * Cette classe définit toutes les constantes utilisées dans l'application
 */
public final class Constantes
{
    // vérification des coordonnées des pixels dessinés dans Main.drawPixel()
    public static final boolean CHECK = false;

    // distance maximale (dépend de la précision des nombres)
    public static final float INFINI = 1e38f;

    // distance minimale (dépend de la taille de la scène)
    public static final float EPSILON = 1e-5f;

    // champ de vision horizontal de la caméra
    public static float CHAMP = 45;

    // la largeur entière de l'écran représente ECHELLE unités du monde
    public static float ECHELLE = 2;

    // dimensions (initiales) et nom du fichier PNG de sortie
    public static int LARGEUR_IMAGE = 800;
    public static int HAUTEUR_IMAGE = 600;
    public static String NOM_IMAGE = "image.png";

    // nombre de rayons réfléchis successifs
    public static int MAX_REFLETS = 5;


    public static void read(final Section sectionini) {
        if (sectionini.containsKey("width")) {
            LARGEUR_IMAGE = Integer.parseInt(sectionini.get("width").trim());
        }

        if (sectionini.containsKey("height")) {
            HAUTEUR_IMAGE = Integer.parseInt(sectionini.get("height").trim());
        }

        if (sectionini.containsKey("filename")) {
            NOM_IMAGE = sectionini.get("filename").trim();
        }

        if (sectionini.containsKey("champ")) {
            CHAMP = Float.parseFloat(sectionini.get("champ").trim());
        }

        if (sectionini.containsKey("echelle")) {
            ECHELLE = Float.parseFloat(sectionini.get("echelle").trim());
        }

        if (sectionini.containsKey("maxreflets")) {
            MAX_REFLETS = Integer.parseInt(sectionini.get("maxreflets").trim());
        }
    }
}
