package fr.enssat.lancer;

/**
 * Cette classe représente le point de contact avec le plus proche objet
 * rencontré par un rayon : l'objet, sa distance au point de départ du rayon et les coordonnées
 */
public class PointContact extends Point {

    // rayon incident
    protected final Rayon incident;

    // plus proche objet rencontré
    protected final Objet3D objet;

    /// distance du point de contact
    protected float distance;



    public PointContact(final Rayon incident, final Point contact, final float distance, final Objet3D objet) {
        super(contact);
        this.incident = incident;
        this.objet = objet;
        this.distance = distance;
    }


    public Objet3D getObjet()
    {
        return objet;
    }


    public float getDistance()
    {
        return distance;
    }
}
